﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace SWF_Download
{
    class DownloadFile
    {
        public string FileName { get; private set; }
        public string URL { get; private set; }

        public bool closeAfterDownload;

        public WebClient Client;

        public DownloadFile(string FileName, string URL, string dir, bool closeAfterDownload)
        {
            this.FileName = FileName;
            this.URL = URL;
            this.closeAfterDownload = closeAfterDownload;
            this.Client = new WebClient();

            Console.WriteLine("Downloading file: " + FileName);

            //this.Client.DownloadProgressChanged += this.client_DownloadProgressChanged;
            this.Client.DownloadFileAsync(new Uri(this.URL), dir + FileName);
            this.Client.DownloadFileCompleted += this.client_DownloadCompleted;
        }

        private void client_DownloadCompleted(object sender, AsyncCompletedEventArgs e)
        {
            Console.WriteLine("Finished downloading: " + this.FileName);

            if (this.closeAfterDownload)
            {
                Program.close = true;
            }
        }

        void client_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            double bytesIn = double.Parse(e.BytesReceived.ToString());
            double totalBytes = double.Parse(e.TotalBytesToReceive.ToString());
            double percentage = bytesIn / totalBytes * 100;
            int percent = int.Parse(Math.Truncate(percentage).ToString());

            Console.WriteLine("Downloaded " + percent + "% (" + bytesIn + "/" + totalBytes + ")");

        }
    }
}
